package directSpread;

import java.awt.Shape;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import cma.CMAEvolutionStrategy;
import cma.CMASolution;
import directSpread.utility.Operator;
import directSpread.utility.Problem;
import directSpread.utility.Solution;
import directSpread.utility.SolutionSet;
import directSpread.utility.WindTurbineProblemFaster;
import windCode.*;


public class TestOpenWindFaster {

    public static void main(String[] args) {
        System.out.println("TestFaster");
        //Algorithm variables
        int maxEvaluations = 10000;
        int populationSize = 1;
        int numberRepetitions = 1;

        //VectorBasedMovementMutation variables
        double probability = 1;
        double reversalProbability = 0.2;
        int nearestNeighbours = 3;
        double directionSigma = Math.PI / 6; // TODO What should this be?
        double distanceMu;// = 5; // TODO What should this be?
        double distanceSigma;// = distanceMu/3; // TODO What should this be?

        //Adaptation variables
        double distanceMuIncrease;
        double distanceSigmaIncrease;
        double distanceMuDecrease;
        double distanceSigmaDecrease;
        double distanceSigmaMax;
        double distanceSigmaMin;
        double distanceMuMax;
        double distanceMuMin;

        //Problem variables
//        int nodes = 5;
//        int nodes = 32;
//        int nodes = 37;
        int nodes = 50;


//		double minimumDistance = 3; //Proximity
        Shape bounds = null; //Bounding area.
        double x1 = 0;
        double y1 = 0;
//		double x2 = minimumDistance*(((int)Math.sqrt(nodes)));
//		double y2 = minimumDistance*(((int)Math.sqrt(nodes))-1);
//		double x2 = minimumDistance*30;
//		double y2 = minimumDistance*30;
//		double x2 = 3000;
//		double y2 = 3000;
//        double x2 = 800;
//        double y2 = 1700;
        double x2 = 3000;
        double y2 = 3000;
//            double x2 = 8000; // for 200
//            double y2 = 5000; // for 200
//            double x2 = 20000; // for 1000
//            double y2 = 10000; // for 1000
//            double x2 = 14000; // for 500
//            double y2 = 7000; // for 500
//        double x2 = 3100;
//        double y2 = 6800;

        int wakeModelScenario = 2;
        String realism = "w"; // scenario number, realism: "[o]ptimal (wakelossfree)"/"consider [w]akeloss"
//        boolean printSeveralOutputsPerDSRun = true;

        boolean displayGUI = !true;
        boolean printSeveralOutputsPerDSRepetition = true;
        boolean printSeveralOutputsPerDSRun = true;
        boolean printEveryEvaluation = !true;
        
        
        
        
        //Creating infeasible zones.
        int infeasibleZonesScenario = 0;
        
//        //blocky
//        int numInfeasibleZones = 8;
//        Rectangle2D[] infeasibleZones = new Rectangle2D[numInfeasibleZones];
//        infeasibleZones[0] = new Rectangle2D.Double(0, 500, 1201, 2801);
//        infeasibleZones[1] = new Rectangle2D.Double(0, 3300, 801, 751);
//        infeasibleZones[2] = new Rectangle2D.Double(0, 4050, 501, 751);
//        infeasibleZones[3] = new Rectangle2D.Double(0, 4800, 1201, 351);
//        infeasibleZones[4] = new Rectangle2D.Double(0, 5150, 1001, 351);
//        infeasibleZones[5] = new Rectangle2D.Double(0, 5500, 1501, 901);
//        infeasibleZones[6] = new Rectangle2D.Double(0, 0, 1601, 501);
//        infeasibleZones[7] = new Rectangle2D.Double(2000, 0, 901, 501);

      int numInfeasibleZones = 100;
      Rectangle2D[] infeasibleZones = new Rectangle2D[numInfeasibleZones];
      infeasibleZones[0] = new Rectangle2D.Double(2730, -1, 271, 251);
      infeasibleZones[1] = new Rectangle2D.Double(2240, -1, 491, 501);
      infeasibleZones[2] = new Rectangle2D.Double(2730, 250, 51, 226);
      infeasibleZones[3] = new Rectangle2D.Double(2780, 250, 51, 201);
      infeasibleZones[4] = new Rectangle2D.Double(2830, 250, 51, 151);
      infeasibleZones[5] = new Rectangle2D.Double(2890, 250, 51, 88);
      infeasibleZones[6] = new Rectangle2D.Double(2930, 250, 51, 50);
      infeasibleZones[7] = new Rectangle2D.Double(3000, -1, 51, 50);
      
      infeasibleZones[8] = new Rectangle2D.Double(1740, -1, 51, 10);
      infeasibleZones[9] = new Rectangle2D.Double(1790, -1, 51, 25);
      infeasibleZones[10] = new Rectangle2D.Double(1840, -1, 51, 60);
      infeasibleZones[11] = new Rectangle2D.Double(1890, -1, 51, 125);
      infeasibleZones[12] = new Rectangle2D.Double(1940, -1, 51, 150);
      infeasibleZones[13] = new Rectangle2D.Double(1990, -1, 51, 175);
      infeasibleZones[14] = new Rectangle2D.Double(2040, -1, 51, 275);
      infeasibleZones[15] = new Rectangle2D.Double(2090, -1, 51, 305);
      infeasibleZones[16] = new Rectangle2D.Double(2140, -1, 51, 375);
      infeasibleZones[17] = new Rectangle2D.Double(2190, -1, 51, 420);
      
      infeasibleZones[18] = new Rectangle2D.Double(0, -1, 1686, 526);
      infeasibleZones[19] = new Rectangle2D.Double(0, 525, 1346, 226);
      infeasibleZones[20] = new Rectangle2D.Double(1345, 525, 51, 150);
      infeasibleZones[21] = new Rectangle2D.Double(1395, 525, 51, 100);
      infeasibleZones[22] = new Rectangle2D.Double(1445, 525, 51, 75);
      infeasibleZones[23] = new Rectangle2D.Double(1495, 525, 51, 30);
      infeasibleZones[24] = new Rectangle2D.Double(1545, 525, 51, 10);

      infeasibleZones[25] = new Rectangle2D.Double(0, 750, 1211, 771);
      infeasibleZones[26] = new Rectangle2D.Double(1210, 750, 51, 151);
      infeasibleZones[27] = new Rectangle2D.Double(1260, 750, 51, 86);
      
      infeasibleZones[28] = new Rectangle2D.Double(0, 1520, 1086, 921);
      infeasibleZones[29] = new Rectangle2D.Double(1085, 1520, 26, 176);
      infeasibleZones[30] = new Rectangle2D.Double(1110, 1520, 26, 121);
      infeasibleZones[31] = new Rectangle2D.Double(1135, 1520, 51, 61);
      
      infeasibleZones[31] = new Rectangle2D.Double(1085, 2180, 126, 261);
      infeasibleZones[32] = new Rectangle2D.Double(1085, 2055, 51, 126);
      infeasibleZones[33] = new Rectangle2D.Double(1135, 2150, 51, 31);
      
      infeasibleZones[34] = new Rectangle2D.Double(0, 2440, 1126, 151);
      infeasibleZones[35] = new Rectangle2D.Double(0, 2590, 1136, 926);
      infeasibleZones[36] = new Rectangle2D.Double(1135, 2590, 66, 801);
      infeasibleZones[37] = new Rectangle2D.Double(0, 3155, 1261, 151);
      infeasibleZones[38] = new Rectangle2D.Double(0, 2940, 1251, 76);
      
      infeasibleZones[39] = new Rectangle2D.Double(735, 3515, 116, 251);
      infeasibleZones[40] = new Rectangle2D.Double(850, 3705, 51, 51);
      infeasibleZones[41] = new Rectangle2D.Double(670, 3365, 51, 66);
      infeasibleZones[42] = new Rectangle2D.Double(0, 3515, 736, 101);
      
      infeasibleZones[43] = new Rectangle2D.Double(0, 3615, 601, 901);
      infeasibleZones[44] = new Rectangle2D.Double(600, 3745, 81, 711);
      infeasibleZones[45] = new Rectangle2D.Double(680, 3845, 61, 546);
      infeasibleZones[46] = new Rectangle2D.Double(740, 3895, 41, 441);
      infeasibleZones[47] = new Rectangle2D.Double(780, 3895, 46, 191);
      infeasibleZones[48] = new Rectangle2D.Double(825, 3970, 41, 116);
      infeasibleZones[49] = new Rectangle2D.Double(780, 4165, 66, 171);
      
      infeasibleZones[50] = new Rectangle2D.Double(0, 3745, 526, 741);
      infeasibleZones[51] = new Rectangle2D.Double(0, 4485, 451, 136);
      infeasibleZones[52] = new Rectangle2D.Double(0, 4485, 451, 196);
      infeasibleZones[53] = new Rectangle2D.Double(0, 4680, 511, 286);
      infeasibleZones[54] = new Rectangle2D.Double(510, 4830, 41, 196);
      infeasibleZones[55] = new Rectangle2D.Double(510, 4910, 71, 116);
      
      infeasibleZones[56] = new Rectangle2D.Double(0, 4965, 461, 1836);
      infeasibleZones[57] = new Rectangle2D.Double(0, 5100, 491, 1701);
      infeasibleZones[58] = new Rectangle2D.Double(0, 5175, 556, 1626);
      infeasibleZones[59] = new Rectangle2D.Double(0, 5265, 1136, 446);
      infeasibleZones[60] = new Rectangle2D.Double(630, 5175, 51, 200);
      infeasibleZones[61] = new Rectangle2D.Double(680, 5220, 26, 200);
      
      infeasibleZones[62] = new Rectangle2D.Double(915, 5235, 66, 200);
      infeasibleZones[63] = new Rectangle2D.Double(1140, 5235, 126, 151);
      
      infeasibleZones[64] = new Rectangle2D.Double(0, 5265, 861, 1536);
      infeasibleZones[65] = new Rectangle2D.Double(860, 5710, 101, 91);
      
      infeasibleZones[66] = new Rectangle2D.Double(860, 5910, 136, 891);
      
      infeasibleZones[67] = new Rectangle2D.Double(995, 5985, 391, 76);
      infeasibleZones[68] = new Rectangle2D.Double(995, 6060, 261, 66);
      infeasibleZones[69] = new Rectangle2D.Double(995, 6120, 391, 101);
      infeasibleZones[70] = new Rectangle2D.Double(995, 6220, 301, 101);
      infeasibleZones[71] = new Rectangle2D.Double(995, 6310, 451, 176);
      infeasibleZones[72] = new Rectangle2D.Double(995, 6480, 401, 186);
      infeasibleZones[73] = new Rectangle2D.Double(995, 6665, 526, 66);
      infeasibleZones[74] = new Rectangle2D.Double(995, 6730, 726, 71);
      


        // consider command line arguments, if there are any
        if (args.length == 8) {
            nodes = Integer.parseInt(args[0]);
            maxEvaluations = Integer.parseInt(args[1]);
            wakeModelScenario = Integer.parseInt(args[2]);
            x2 = Integer.parseInt(args[3]);
            y2 = Integer.parseInt(args[4]);
            nearestNeighbours = Integer.parseInt(args[5]);
            numberRepetitions = Integer.parseInt(args[6]);
            displayGUI = Boolean.parseBoolean(args[7]);
            
//            infeasibleZonesScenario = Integer.parseInt(args[8]);
        }

        
        switch (infeasibleZonesScenario) {
                case 0: 
                    // use trivial zone as an 'empty scenario' 
                    infeasibleZones = new Rectangle2D[]{new Rectangle2D.Double(1, 1, 0, 0)}; 
                    break;
                case 1:
                    // use default scenario from above
                    break;
                default:
                    // use trivial zone as an 'empty scenario' 
                    infeasibleZones = new Rectangle2D[]{new Rectangle2D.Double(1, 1, 0, 0)}; 
                    break;
            }

        Area area = null;
        boolean rectangle = !false;
        if (rectangle) {
            bounds = new Rectangle2D.Double(x1, y1, x2 - x1, y2 - y1);
            area = new RectangularArea(nodes, x2, y2, infeasibleZones);
        } else {
            bounds = new Ellipse2D.Double(x1, y1, x2 - x1, y2 - y1);
        }


        double minimumDistance = 8 * WakeModelFaster.R;


        //Default movement variables
        distanceMu = area.computeInitialStandardDeviation() * 32;
        distanceSigma = distanceMu / 3;
        //End movement variables
        System.out.println("distanceMu=" + distanceMu);

        //Adaptation variables
        distanceMuIncrease = 1.5;
        distanceSigmaIncrease = 1.5;
        distanceMuDecrease = 1.5;
        distanceSigmaDecrease = 1.5;
        distanceSigmaMax = distanceSigma * 2;
        distanceSigmaMin = 1;//distanceSigma/2;
        distanceMuMax = distanceMu * 2;
        distanceMuMin = distanceMu / 2;
        //End adaptation variables


        System.out.println("Algorithm begins");




        WakeModelFaster fitfun = new WakeModelFaster(wakeModelScenario, realism);



        area.printSeveralOutputs = printSeveralOutputsPerDSRun;


        System.out.println("Wind Farm Layout Optimization - DirectSpread");
        
        System.out.println(
        "nodes:"+nodes+", wakeModelScenario:"+wakeModelScenario+
        ", nearestNeighbours:"+nearestNeighbours+", displayGUI:"+displayGUI);
        
        
//        System.out.println("("+commandLineMu+","+commandLineLambda+")-DS, generations:"+commandLineGenerations+", repetitions:"+commandLineRepetitions);
        System.out.println("maxEvaluations:" + maxEvaluations + ", repetitions:" + numberRepetitions);
//        System.out.println("workerThreads="+commandLineWorkerThreads);
//        System.out.println("commandLineComment: '"+commandLineComment+"'");
        System.out.println("infeasible regions:" + infeasibleZones.toString()+ "[zones: "+infeasibleZones.length + ", scenario:" +infeasibleZonesScenario+"]");
        System.out.println();

      System.out.println(area.toString());

      WindTurbineProblemFaster problem = new WindTurbineProblemFaster(nodes,
      		minimumDistance, bounds, area, wakeModelScenario, realism,
      		distanceMu, distanceSigma, directionSigma, 
      		distanceMuIncrease, distanceSigmaIncrease, distanceMuDecrease, distanceSigmaDecrease,
      		distanceSigmaMax, distanceSigmaMin, distanceMuMax, distanceMuMin);
//      WindTurbineProblemFaster problem = new WindTurbineProblemFaster(nodes, minimumDistance, bounds, area, wakeModelScenario, realism);
      
      
      long startTime, stopTime;
      startTime = System.currentTimeMillis();
      Solution bestSolution = runDSSeveralTimes(problem, area, bounds, x2, y2, fitfun, populationSize, populationSize, maxEvaluations,
    		  printEveryEvaluation, printSeveralOutputsPerDSRun, printSeveralOutputsPerDSRepetition, displayGUI, 
          numberRepetitions, directionSigma, distanceMu, distanceSigma, 
          nearestNeighbours, probability, reversalProbability, infeasibleZones
//          ,commandLineWorkerThreads
          );
      stopTime = System.currentTimeMillis();
      double timeNeeded = (stopTime-startTime)/1000d;

      double wakeloss = 1d/fitfun.computeWakelossFreeFitness(area.startingSolution()) - 1d/bestSolution.getObjectives()[0];
      System.out.println("turbines="+area.numberOfTurbines+", energy="+1d/bestSolution.getObjectives()[0] + ", wakeloss="+wakeloss+", secondsNeeded="+timeNeeded);
		
		
		
//		System.out.println("Finished algorithm with best fitness " + resultantPopulation.get(0).getObjectives()[0]);
	}
    
    
    
    public static Solution runDSOnce(Problem problem, Area area, Shape bounds, double x2, double y2, WakeModelFaster fitfun, int populationSize, int lambda, int maxEvaluations, 
    		boolean printEveryEvaluation, boolean printSeveralOutputsPerDSRun, boolean displayGUI,
    		double directionSigma, double distanceMu, double distanceSigma,
    		int nearestNeighbours, double probability, double reversalProbability, Rectangle2D[] infeasibleZones) {
    	
    	OpenWindMutation mutation = new OpenWindMutation(probability, nearestNeighbours, 
                bounds, area, x2, y2, windCode.WakeModelFaster.R*8, /*directionSigma, distanceMu, distanceSigma,*/ reversalProbability);
//        VectorBasedMovementMutation mutation = new VectorBasedMovementMutation(probability, nearestNeighbours, 
//                bounds, area, x2, y2, windCode.WakeModelFaster.R*8, directionSigma, distanceMu, distanceSigma, reversalProbability);
		WindTurbineAlgorithmFaster algorithm = new WindTurbineAlgorithmFaster(problem, bounds, windCode.WakeModelFaster.R*8, mutation, maxEvaluations, populationSize, 
				printEveryEvaluation, printSeveralOutputsPerDSRun, displayGUI, infeasibleZones);

    	SolutionSet resultantPopulation = algorithm.execute();
		return resultantPopulation.get(0);
    }
    
    
    
    public static Solution runDSSeveralTimes(Problem problem, Area area, Shape bounds, double x2, double y2, WakeModelFaster fitfun, int mu, int lambda, int maxEvaluations,
            boolean printEveryEvaluation, boolean printSeveralOutputsPerDSRun, boolean printSeveralOutputsPerDSRepetition, boolean displayGUI,
            int repetitions, double directionSigma, double distanceMu, double distanceSigma,
            int nearestNeighbours, double probability, double reversalProbability, Rectangle2D[] infeasibleZones
//            int workerThreads
            ) {
        Solution bestSolution = null;
        Solution[] solutions = new Solution[repetitions];

        for (int rep = 0; rep<repetitions; rep++) {

            if (printSeveralOutputsPerDSRepetition) {
                System.out.print("$repetition:"+rep);
                System.out.println(" [" + DateUtils.now()+"]");
            }

            long startTime, stopTime;
            startTime = System.currentTimeMillis();
            Solution temp = runDSOnce(problem, area, bounds, x2, y2, fitfun, mu, lambda, maxEvaluations, 
            		printEveryEvaluation, printSeveralOutputsPerDSRun, displayGUI, 
            		directionSigma, distanceMu, distanceSigma,
            		nearestNeighbours, probability, reversalProbability, infeasibleZones);//, workerThreads);
            stopTime = System.currentTimeMillis();

            solutions[rep]=temp;

            // remember: CMA minimizes!
            if (bestSolution == null || (temp.getObjectives()[0] < bestSolution.getObjectives()[0])) {
                bestSolution = temp;
            }
            if (printSeveralOutputsPerDSRepetition)
                System.out.println("$repetition:"+rep+
                        ", newBest:"+1d/bestSolution.getObjectives()[0]+ ", bestHere:"+1d/temp.getObjectives()[0] +
                        " (time:+"+ (stopTime-startTime)/1000d +")"
                        );
        }

        if (printSeveralOutputsPerDSRepetition) {
            System.out.println("Best Solution found:");
//            double[] energyPerTurbine = fitfun.energyPerTurbine(bestSolution.getDecisionVariableAsDoubleArray(), false, null, -1);
            double[] energyPerTurbine = bestSolution.energyPerTurbine;
            WakeModelFaster.printSolution(bestSolution, energyPerTurbine);
        }

        //calculate mean:
        double mean = 0;
        for (Solution i : solutions) {
            mean += 1d/i.getObjectives()[0];
        }
        mean = mean/repetitions;
        double stdev = getStdDev(solutions);
        if (printSeveralOutputsPerDSRepetition)
                System.out.println(">> mean:"+mean+" stdev:"+stdev);

        return bestSolution;
    }

    
    
    
    
//    
//    public static Solution runDSOnce(Area area, WakeModelFaster fitfun, int mu, int lambda, int generations,
//            boolean printSeveralOutputsPerDSRun, double initialStandardDeviation,
//            int workerThreads) {
//        long startTime2, stopTime2;
//        boolean printEvaluationTimes = !true;
////        area.printSeveralOutputs = printSeveralOutputsPerDSRun;
//
//        // new a CMA-ES and set some initial values
////        CMAEvolutionStrategy cma = new CMAEvolutionStrategy();
//        //cma.readProperties(); // read options, see file CMAEvolutionStrategy.properties
//        //cma.parameters.setCcov(0);
////        cma.parameters.setPopulationSize(lambda);
////        cma.parameters.setMu(mu);
////        cma.parameters.setPopulationSize(lambda);
//        /* Note: it looks like cma initally samples solutions until
//         * the initial populations contains feasible search points only.
//         * Thus, using 9 turbines on the 500m-radiusFarm "practically" never
//         * goes past the initialization.
//         */
//
////        cma.setDimension(2*areal.numberOfTurbines); // overwrite some loaded properties
//        //cma.setInitialX(0.0); // in each dimension, also setTypicalX can be used
//
//        double[] startingPoint = area.startingSolution();
//        double wakelossFreeFitness = fitfun.computeWakelossFreeFitness(startingPoint);
//        System.out.println("initial="+1d/fitfun.valueOf(startingPoint, true)+", wakelossfree="+1d/wakelossFreeFitness);
//        double[] energyPerTurbine = fitfun.energyPerTurbine(startingPoint, false);
//        WakeModelFaster.printSolution(startingPoint, energyPerTurbine);
////        WakeModelFaster.printSolution(startingPoint);
//
//
////        cma.setInitialX(startingPoint);
//
//        //cma.setInitialStandardDeviation(0.2); // also a mandatory setting
////        cma.setInitialStandardDeviation(initialStandardDeviation); // also a mandatory setting
//        //cma.setInitialStandardDeviation(fitfun.farmRadius/2); // reasonable stdev for initialization?
////        cma.options.stopFitness = 1e-19;       // optional setting, originally 1e-9;
//        
//
//        // initialize cma and get fitness array to fill in later
//        double[] fitness = cma.init();  // new double[cma.parameters.getPopulationSize()];
//
//        // initial output to files
////        cma.writeToDefaultFilesHeaders(0); // 0 == overwrites old files
//
//        // iteration loop
////        while (cma.stopConditions.getNumber() == 0) {
//        long startTime, stopTime;
//        int countResamplesPerRun = 0;
//        int countResamplesPerGeneration = 0;
//        while (cma.getCountIter() <= generations) {
//
//            startTime = System.currentTimeMillis();
//            // break if no improvement for long time
//            if (cma.getCountIter()>0 && (cma.getCountEval()-cma.getBestSolution().getEvaluationNumber())>lambda*500 ) {
//                System.out.println("break: no improvement for evals="+lambda*500);
//                break;
//            }
//
//            // two lines of code for more frequent output of the EA
//            if (printSeveralOutputsPerCMARun) {
//                if (cma.getCountIter() % 5 ==1 ) System.out.print("["+cma.getCountIter()+":"+1d/cma.getBestFunctionValue()+"]");
//                if (cma.getCountIter() % 25 ==0 && cma.getCountIter()>0) System.out.println();
//                if (cma.getCountIter() % 50 ==0 && cma.getCountIter()>0) {
//                    System.out.println("best placement found so far");
//                    energyPerTurbine = fitfun.energyPerTurbine(cma.getBestSolution().getX(), false);
//                    WakeModelFaster.printSolution(cma.getBestSolution(), energyPerTurbine);
////                    WakeModelFaster.printSolution(cma.getBestSolution());
//                }
//            }
//            if (printSeveralOutputsPerCMARun) {
//                System.out.println("[generation:" + cma.getCountIter() +
//                        ", bestSoFar: "+(1.0/cma.getBestFunctionValue())+
//                        ", distanceToWakelossFree:" + ((1.0/cma.getBestFunctionValue()) - (1.0/wakelossFreeFitness)) +
//                        ", evaluationNumber:" + cma.getBestEvaluationNumber() +
//                        "]");
//                System.out.println("[generation:" + cma.getCountIter() +
//                        ", bestRecent:"+(1.0/cma.getBestRecentFunctionValue())+
//                        ", distanceToWakelossFree:" + ((1.0/cma.getBestRecentFunctionValue()) - (1.0/wakelossFreeFitness)) +
//                        ", evaluationNumber:" + cma.getBestRecentSolution().getEvaluationNumber() +
//                        "]" );
//            }
//            //WakeModelFaster.printSolution(cma.getBestSolution());
//
//            // fitness function can be modified on-the-fly (for problem 'Simple')
//            // (can be used to introduce penalty terms)
//            // if (cma.getCountIter() % 1000 == 0) fitfun.border = Math.random();
//
//            // --- core iteration step ---
//            //sample population
////            countResamplesPerGeneration = 0;
////            double[][] pop = cma.samplePopulation(areal); // get a new population of solutions
////            for (int i = 0; i < pop.length; ++i) {    // for each candidate solution i
////                // a simple way to handle constraints that define a convex feasible domain
////                // (like box constraints, i.e. variable boundaries) via "blind re-sampling"
////                // assumes that the feasible domain is convex, the optimum is
////                int countResamples = 0;
////
////                //while (!fitfun.isFeasible(pop[i], areal)) //   not located on (or very close to) the domain boundary,
////                
////        //pop[i] = areal.fixSolution(pop[i]); //possibly fix the newly sampled solution
////        //WakeModelFaster.printSolution(pop[i]);
////                while (!fitfun.isFeasible(pop[i], areal)) //   not located on (or very close to) the domain boundary,
////                {
////                    pop[i] = cma.resampleSingle(i);    //   initialX is feasible and initialStandardDeviations are
////                    pop[i] = areal.fixSolution(pop[i]); //possibly fix the newly sampled solution
////                    countResamples++;
////                    // start from the beginning when 100 resamples were necessary!
////                    if (countResamples>100) {
////                        pop[i] = areal.startingSolution();
////                        System.out.println("!");// sublimal hint that the EA is having problems as too many resamples are needed
////                        break;
////                    }
////                }                                                       //   sufficiently small to prevent quasi-infinite looping here
////                if (countResamples>0 && false) System.out.println("resampled: "+countResamples);
////                // compute fitness/objective value
//////                System.out.println(fitness[i]);
////            //    fitness[i] = fitfun.valueOf(pop[i], printEvaluationTimes); // fitfun.valueOf() is to be minimized
//////                System.out.println(fitness[i]);
////                countResamplesPerRun += countResamples;
////                countResamplesPerGeneration += countResamples;
////            }
////
//            // make sure that areal.startingSolution() is contained at least once in the beginning
//            // actually: due to (X,Y)-ES it is not sure whether this helps at all
////            if (cma.getCountIter()==0 || cma.getCountIter()==1) {
////                pop[0] = areal.startingSolution();
////            }
////
//            //overwrite old fitness values
////            for (int i = 0; i < pop.length; ++i) {    // for each candidate solution i
////                fitness[i] = 0d;
////            }
////
////            
////            startTime2 = System.currentTimeMillis();
////
////            //now: determine fitnesses
//////            if (workerThreads == 1) {
//////                //old school: 1 by 1
//////                for (int i = 0; i < pop.length; ++i) {    // for each candidate solution i
//////    //                System.out.println("before"+fitness[i]);
//////                    fitness[i] = fitfun.valueOf(pop[i], printEvaluationTimes); // fitfun.valueOf() is to be minimized
//////    //                System.out.println("after "+fitness[i]);
//////                }
//////            } else {
//////                //parallelized :)
//////                
//////                ParallelizedEvaluation.parallelizeEvaluation(workerThreads, fitfun, pop, fitness, printEvaluationTimes);
//////                stopTime2 = System.currentTimeMillis();
//////                if (true) System.out.println("EndOfGeneration:"+(stopTime2-startTime2)/1000d+"s"+"("+Thread.currentThread().activeCount()+")");
//////            }
////
////            cma.updateDistribution(fitness);         // pass fitness array to update search distribution
////
////            stopTime2 = System.currentTimeMillis();
////            if (true) System.out.println("EndUpdateDistribution:"+(stopTime2-startTime2)/1000d+"s"+"("+Thread.currentThread().activeCount()+")");
////
//            // --- end core iteration step ---
////
//            // output to files and console
////            if (!true) {
////                cma.writeToDefaultFiles();
////                int outmod = 15;
////                if (cma.getCountIter() % (15 * outmod) == 1) {
////                    cma.printlnAnnotation(); // might write file as well
////                }
////                if (cma.getCountIter() % outmod == 1) {
////                    cma.println();
////                }
////            }
//
//            stopTime = System.currentTimeMillis();
//            if (printSeveralOutputsPerCMARun) System.out.println("seconds needed for this generation:"+(stopTime-startTime)/1000d);
//            if (printSeveralOutputsPerCMARun) System.out.println("countResamplesPerGeneration:"+countResamplesPerGeneration);
//            if (printSeveralOutputsPerCMARun) System.out.println("countResamplesPerRun:"+countResamplesPerRun);
//
//
//
//            if (cma.getCountIter() % 100==0) {
//            System.out.println(cma.sigma);
//            print2DArray(cma.C); }
//        }
//
//        if (printSeveralOutputsPerCMARun) System.out.println("["+(cma.getCountIter()-1)+":"+1d/cma.getBestFunctionValue()+"]");
//
//
//        // evaluate mean value as it is the best estimator for the optimum
////        cma.setFitnessOfMeanX(fitfun.valueOf(cma.getMeanX(), false)); // updates the best ever solution
//
//
//        //hide a lot of output
////        if (false) {
////            // final output
////            cma.writeToDefaultFiles(1);
////            cma.println();
////            cma.println("Terminated due to");
////            for (String s : cma.stopConditions.getMessages()) {
////                cma.println("  " + s);
////            }
////            cma.println("best function value " + 1d/cma.getBestFunctionValue()
////                    + " at evaluation " + cma.getBestEvaluationNumber());
////
////            // we might return cma.getBestSolution() or cma.getBestX()
////        }
//        //System.out.println("["+cma.getCountIter()+":"+1d/cma.getBestFunctionValue()+"]");
////        if (printSeveralOutputsPerCMARun) System.out.println("countResamplesPerRun:"+countResamplesPerRun);
//        return cma.getBestSolution();
//    }
//    
//    
    
    
    
    
    
    
    
    // own implementation to check whether Statistics.getStdDev() works correctly.
    // result: it does.
    public static double getStdDev(Solution[] input) {
        double result = 0;
        double mean = 0;
        double stdev = 0;

        // calculate mean
        for (int i = 0; i < input.length; i++) {
            mean += 1d/input[i].getObjectives()[0];
            //mean += input[i].doubleValue();
        }
        mean = mean/input.length;

        // calculate stdev
        for (int i = 0; i < input.length; i++) {
            stdev = stdev + Math.pow( 1d/input[i].getObjectives()[0] - mean, 2);
        }
        stdev = Math.sqrt(stdev/(input.length-1));

        //System.out.println(" mean:"+mean+" stdev:"+stdev);
        return stdev;

    }

}

