package directSpread.utility;
import java.util.ArrayList;

public class SolutionSet {

	private ArrayList<Solution> solutions;
	private int populationSize;
	
	public SolutionSet(int populationSize) {		
		this.populationSize = populationSize;
		solutions = new ArrayList<Solution>(populationSize);
	}

	public void add(Solution newSolution) {
		if (solutions.size() >= populationSize){
			System.err.println("Error in SolutionSet.add: attempting to add too many solutions.");
			System.exit(1);
		}
		solutions.add(newSolution);
	}

	public Solution get(int index) {
		return solutions.get(index);
	}

	public void set(int i, Solution solution) {
		solutions.set(i, solution);
	}
	
	public int size(){
		return solutions.size();
	}

	public SolutionSet union(SolutionSet solutionSet) {
            boolean debugPrint = !true;


            if (debugPrint) System.out.println("union/1");

            int newSize = this.size() + solutionSet.size();
	        
	    //Create a new population 
	    SolutionSet union = new SolutionSet(newSize);                
	    for (int i = 0; i < this.size(); i++) {      
                union.add(this.get(i));
                if (debugPrint) System.out.println(" i"+i+"="+this.get(i).getObjectives()[0]);

	    } // for
	        
	    for (int i = this.size(); i < (this.size() + solutionSet.size()); i++) {
                union.add(solutionSet.get(i-this.size()));
                if (debugPrint) System.out.println(" i"+i+"="+solutionSet.get(i-this.size()).getObjectives()[0]);
	    } // for

	    return union;        
	}

}
