package windCode;

import cma.*;
import cma.fitness.IObjectiveFunction;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;

/** 
 * @author mwagner
 */
public class Wind {

    public static void main(String[] args) {
        System.out.println("Now: " + DateUtils.now());
        int commandLineWorkerThreads = 1;
        int commandLineNumberOfTurbines = 10;
//        int commandLineNumberOfTurbines = 1000;
        //int commandLineGenerations = 10000;
        int commandLineGenerations = 5000;
        int commandLineWakeModelScenario = 2;
        String commandLineComment = "no commandLineComment specified";

        int commandLineMu = 10;
        int commandLineLambda = 20;
/*
int bestMu = 0;
int bestLambda = 0;
double bestestEnergy = 0;
double[][]range = new double[5][7];
for (int i = 0; i < 5; i++){
	for (int j = 0; j < 7; j++){
		commandLineMu = 5 + 5*i;
		commandLineLambda = 5 + 5*j;
		if (commandLineMu > commandLineLambda) continue;
*/
	
	
	
	
        int commandLineWidth = 3000; // 20, 14, 12, 10,  8
        int commandLineHeight = 3000; // 10,  7,  6,  6,  5

        int commandLineRepetitions = 1;

        String realism = "w"; // scenario number, realism: "[o]ptimal (wakelossfree)"/"consider [w]akeloss"

        if (args.length==9) {                          /////////////////////// DO NEVER FORGET TO UPDATE THIS LINE!!!!!!!!!!!
            commandLineWorkerThreads = Integer.parseInt(args[0]);
            commandLineNumberOfTurbines = Integer.parseInt(args[1]);
            commandLineGenerations = Integer.parseInt(args[2]);
            commandLineWakeModelScenario = Integer.parseInt(args[3]);
            commandLineMu = Integer.parseInt(args[4]);
            commandLineLambda = Integer.parseInt(args[5]);
            commandLineWidth = Integer.parseInt(args[6]);
            commandLineHeight = Integer.parseInt(args[7]);
            commandLineRepetitions = Integer.parseInt(args[8]);
//            commandLineComment = args[9];
        }

        Area area;
        CMASolution bestSolution = null;
        String tempS = "";

        double windFarmRadius = 500;

//        double width = 10000; double height = 20000; //8*R=308
//                double width = 10000; double height = 5000; //8*R=308
//        double width = 2772; double height = 15092; //8*R=308
//        double width = 3000; double height = 3000; //8*R=308

        WakeModel fitfun = new WakeModel(commandLineWakeModelScenario, realism);

        //int mu = 20; int lambda = 120;
//        int mu = 10; int lambda = 60;
//        int mu = 1; int lambda = 2;
//        int mu = 10; int lambda = 20;

        
//        int repetitions = 1;
        // 10,60x5:8minutes
        // 10,60x2000:53h?
        
        boolean printSeveralOutputsPerCMARepetition = !false;
        boolean printSeveralOutputsPerCMARun = !false;

        System.out.println("Wind Farm Layout Optimization");
        System.out.println("("+commandLineMu+","+commandLineLambda+")-ES, generations:"+commandLineGenerations+", repetitions:"+commandLineRepetitions);
        System.out.println("workerThreads="+commandLineWorkerThreads);
        System.out.println("commandLineComment: '"+commandLineComment+"'");
        System.out.println();

//        for (int turbs = 1000; turbs<=1000; turbs+=10) {
//        for (int turbs = 10; turbs<=100; turbs+=10) {
        for (int turbs = commandLineNumberOfTurbines; turbs<=commandLineNumberOfTurbines; turbs+=10) {
        //for (int turbs = 70; turbs<=70; turbs+=10) {
//        for (int turbs = 3; turbs<=9; turbs+=1) {
            
            
            area = new RectangularArea(turbs, commandLineWidth, commandLineHeight);
//            areal = new CircularArea(turbs, windFarmRadius);


            System.out.println(area.toString());
//            areal = new CircularArea(turbs, windFarmRadius);
            
            double initialStandardDeviation = area.computeInitialStandardDeviation(); 
            if (!false) System.out.println("init stDev="+initialStandardDeviation);

            long startTime, stopTime;
            startTime = System.currentTimeMillis();
            bestSolution = runCMASeveralTimes(area, fitfun, commandLineMu, commandLineLambda, commandLineGenerations,
                printSeveralOutputsPerCMARun, printSeveralOutputsPerCMARepetition, 
                commandLineRepetitions, initialStandardDeviation,
                commandLineWorkerThreads);
            stopTime = System.currentTimeMillis();
            double timeNeeded = (stopTime-startTime)/1000d;

            double wakeloss = 1d/fitfun.computeWakelossFreeFitness(area.startingSolution()) - 1d/bestSolution.getFitness();
            System.out.println("turbines="+area.numberOfTurbines+", energy="+1d/bestSolution.getFitness() + ", wakeloss="+wakeloss+", secondsNeeded="+timeNeeded);
            
            
        }
 
   /*     
if (1d/bestSolution.getFitness() > bestestEnergy){
    bestestEnergy = 1d/bestSolution.getFitness();
    bestLambda = commandLineLambda;
    bestMu = commandLineMu;
}
range[i][j] = 1d/bestSolution.getFitness();
try{
java.io.FileWriter fileW = new java.io.FileWriter("70TurbineTest", true);
java.io.BufferedWriter writer = new java.io.BufferedWriter(fileW);
writer.write("Lambda: " + commandLineLambda + ", Mu: " + commandLineMu + ", Energy: " + 1d/bestSolution.getFitness());
writer.newLine();
writer.flush();
writer.close();
fileW.close();
}catch(Exception e){}
}
}

for (int i = 0; i < 5; i++){
	for (int j = 0; j < 7; j++){
		System.out.print(range[i][j] + " ");
	}
	System.out.println();
}*/

System.out.println("\n\nBest energy: " + 1d/bestSolution.getFitness() + " was at lambda=" + commandLineLambda + " and mu=" + commandLineMu);
    }


    public static CMASolution runCMASeveralTimes(Area areal, WakeModel fitfun, int mu, int lambda, int generations,
            boolean printSeveralOutputsPerCMARun, boolean printSeveralOutputsPerCMARepetition, 
            int repetitions, double initialStandardDeviation,
            int workerThreads) {
        CMASolution bestSolution = null;
        CMASolution[] solutions = new CMASolution[repetitions];

        for (int rep = 0; rep<repetitions; rep++) {

            if (printSeveralOutputsPerCMARepetition) {
                System.out.print("$repetition:"+rep);
                System.out.println(" [" + DateUtils.now()+"]");
            }

            long startTime, stopTime;
            startTime = System.currentTimeMillis();
            CMASolution temp = runCMAOnce(areal, fitfun, mu, lambda, generations, printSeveralOutputsPerCMARun, initialStandardDeviation, workerThreads);
            stopTime = System.currentTimeMillis();

            solutions[rep]=temp;

            // remember: CMA minimizes!
            if (bestSolution == null || (temp.getFitness() < bestSolution.getFitness())) {
                bestSolution = temp;
            }
            if (printSeveralOutputsPerCMARepetition)
                System.out.println("$repetition:"+rep+
                        ", newBest:"+1d/bestSolution.getFitness()+ ", bestHere:"+1d/temp.getFitness() +
                        " (time:+"+ (stopTime-startTime)/1000d +")"
                        );
        }

        if (printSeveralOutputsPerCMARepetition) {
            System.out.println("Best Solution found:");
            double[] energyPerTurbine = fitfun.energyPerTurbine(bestSolution.getX(), false);
            WakeModel.printSolution(bestSolution, energyPerTurbine);
        }

        //calculate mean:
        double mean = 0;
        for (CMASolution i : solutions) {
            mean += 1d/i.getFitness();
        }
        mean = mean/repetitions;
        double stdev = getStdDev(solutions);
        if (printSeveralOutputsPerCMARepetition)
                System.out.println(">> mean:"+mean+" stdev:"+stdev);

        return bestSolution;
    }


    // own implementation to check whether Statistics.getStdDev() works correctly.
    // result: it does.
    public static double getStdDev(CMASolution[] input) {
        double result = 0;
        double mean = 0;
        double stdev = 0;

        // calculate mean
        for (int i = 0; i < input.length; i++) {
            mean += 1d/input[i].getFitness();
            //mean += input[i].doubleValue();
        }
        mean = mean/input.length;

        // calculate stdev
        for (int i = 0; i < input.length; i++) {
            stdev = stdev + Math.pow( 1d/input[i].getFitness() - mean, 2);
        }
        stdev = Math.sqrt(stdev/(input.length-1));

        //System.out.println(" mean:"+mean+" stdev:"+stdev);
        return stdev;

    }



    //public static ISolutionPoint runCMAOnce(Areal areal, WakeModel fitfun, int mu, int lambda, int generations, boolean printSeveralOutputsPerCMARun) {
    public static CMASolution runCMAOnce(Area areal, WakeModel fitfun, int mu, int lambda, int generations,
            boolean printSeveralOutputsPerCMARun, double initialStandardDeviation,
            int workerThreads) {
        long startTime2, stopTime2;
        boolean printEvaluationTimes = !true;
        areal.printSeveralOutputs = printSeveralOutputsPerCMARun;

        // new a CMA-ES and set some initial values
        CMAEvolutionStrategy cma = new CMAEvolutionStrategy();
        //cma.readProperties(); // read options, see file CMAEvolutionStrategy.properties
        //cma.parameters.setCcov(0);
//        cma.parameters.setPopulationSize(lambda);
        cma.parameters.setMu(mu);
        cma.parameters.setPopulationSize(lambda);
        /* Note: it looks like cma initally samples solutions until
         * the initial populations contains feasible search points only.
         * Thus, using 9 turbines on the 500m-radiusFarm "practically" never
         * goes past the initialization.
         */

        cma.setDimension(2*areal.numberOfTurbines); // overwrite some loaded properties
        //cma.setInitialX(0.0); // in each dimension, also setTypicalX can be used

        double[] startingPoint = areal.startingSolution();
        double wakelossFreeFitness = fitfun.computeWakelossFreeFitness(startingPoint);
        System.out.println("initial="+1d/fitfun.valueOf(startingPoint, true)+", wakelossfree="+1d/wakelossFreeFitness);
        double[] energyPerTurbine = fitfun.energyPerTurbine(startingPoint, false);
        WakeModel.printSolution(startingPoint, energyPerTurbine);
//        WakeModel.printSolution(startingPoint);


        cma.setInitialX(startingPoint);

        //cma.setInitialStandardDeviation(0.2); // also a mandatory setting
        cma.setInitialStandardDeviation(initialStandardDeviation); // also a mandatory setting
        //cma.setInitialStandardDeviation(fitfun.farmRadius/2); // reasonable stdev for initialization?
        cma.options.stopFitness = 1e-19;       // optional setting, originally 1e-9;
        

        // initialize cma and get fitness array to fill in later
        double[] fitness = cma.init();  // new double[cma.parameters.getPopulationSize()];

        // initial output to files
        cma.writeToDefaultFilesHeaders(0); // 0 == overwrites old files

        // iteration loop
//        while (cma.stopConditions.getNumber() == 0) {
        long startTime, stopTime;
        int countResamplesPerRun = 0;
        int countResamplesPerGeneration = 0;
        while (cma.getCountIter() <= generations) {

            startTime = System.currentTimeMillis();
            // break if no improvement for long time
            if (cma.getCountIter()>0 && (cma.getCountEval()-cma.getBestSolution().getEvaluationNumber())>lambda*500 ) {
                System.out.println("break: no improvement for evals="+lambda*500);
                break;
            }

            // two lines of code for more frequent output of the EA
            if (printSeveralOutputsPerCMARun) {
                if (cma.getCountIter() % 5 ==1 ) System.out.print("["+cma.getCountIter()+":"+1d/cma.getBestFunctionValue()+"]");
                if (cma.getCountIter() % 25 ==0 && cma.getCountIter()>0) System.out.println();
                if (cma.getCountIter() % 50 ==0 && cma.getCountIter()>0) {
                    System.out.println("best placement found so far");
                    energyPerTurbine = fitfun.energyPerTurbine(cma.getBestSolution().getX(), false);
                    WakeModel.printSolution(cma.getBestSolution(), energyPerTurbine);
//                    WakeModel.printSolution(cma.getBestSolution());
                }
            }
            if (printSeveralOutputsPerCMARun) {
                System.out.println("[generation:" + cma.getCountIter() +
                        ", bestSoFar: "+(1.0/cma.getBestFunctionValue())+
                        ", distanceToWakelossFree:" + ((1.0/cma.getBestFunctionValue()) - (1.0/wakelossFreeFitness)) +
                        ", evaluationNumber:" + cma.getBestEvaluationNumber() +
                        "]");
                System.out.println("[generation:" + cma.getCountIter() +
                        ", bestRecent:"+(1.0/cma.getBestRecentFunctionValue())+
                        ", distanceToWakelossFree:" + ((1.0/cma.getBestRecentFunctionValue()) - (1.0/wakelossFreeFitness)) +
                        ", evaluationNumber:" + cma.getBestRecentSolution().getEvaluationNumber() +
                        "]" );
            }
            //WakeModel.printSolution(cma.getBestSolution());

            // fitness function can be modified on-the-fly (for problem 'Simple')
            // (can be used to introduce penalty terms)
            // if (cma.getCountIter() % 1000 == 0) fitfun.border = Math.random();

            // --- core iteration step ---
            //sample population
            countResamplesPerGeneration = 0;
            double[][] pop = cma.samplePopulation(areal); // get a new population of solutions
            for (int i = 0; i < pop.length; ++i) {    // for each candidate solution i
                // a simple way to handle constraints that define a convex feasible domain
                // (like box constraints, i.e. variable boundaries) via "blind re-sampling"
                // assumes that the feasible domain is convex, the optimum is
                int countResamples = 0;

                //while (!fitfun.isFeasible(pop[i], areal)) //   not located on (or very close to) the domain boundary,
                
        //pop[i] = areal.fixSolution(pop[i]); //possibly fix the newly sampled solution
        //WakeModel.printSolution(pop[i]);
                while (!fitfun.isFeasible(pop[i], areal)) //   not located on (or very close to) the domain boundary,
                {
                    pop[i] = cma.resampleSingle(i);    //   initialX is feasible and initialStandardDeviations are
                    pop[i] = areal.fixSolution(pop[i]); //possibly fix the newly sampled solution
                    countResamples++;
                    // start from the beginning when 100 resamples were necessary!
                    if (countResamples>100) {
                        pop[i] = areal.startingSolution();
                        System.out.println("!");// sublimal hint that the EA is having problems as too many resamples are needed
                        break;
                    }
                }                                                       //   sufficiently small to prevent quasi-infinite looping here
                if (countResamples>0 && false) System.out.println("resampled: "+countResamples);
                // compute fitness/objective value
//                System.out.println(fitness[i]);
            //    fitness[i] = fitfun.valueOf(pop[i], printEvaluationTimes); // fitfun.valueOf() is to be minimized
//                System.out.println(fitness[i]);
                countResamplesPerRun += countResamples;
                countResamplesPerGeneration += countResamples;
            }

            // make sure that areal.startingSolution() is contained at least once in the beginning
            // actually: due to (X,Y)-ES it is not sure whether this helps at all
            if (cma.getCountIter()==0 || cma.getCountIter()==1) {
                pop[0] = areal.startingSolution();
            }

            //overwrite old fitness values
            for (int i = 0; i < pop.length; ++i) {    // for each candidate solution i
                fitness[i] = 0d;
            }

            
            startTime2 = System.currentTimeMillis();

            //now: determine fitnesses
            if (workerThreads == 1) {
                //old school: 1 by 1
                for (int i = 0; i < pop.length; ++i) {    // for each candidate solution i
    //                System.out.println("before"+fitness[i]);
                    fitness[i] = fitfun.valueOf(pop[i], printEvaluationTimes); // fitfun.valueOf() is to be minimized
    //                System.out.println("after "+fitness[i]);
                }
            } else {
                //parallelized :)
                
                ParallelizedEvaluation.parallelizeEvaluation(workerThreads, fitfun, pop, fitness, printEvaluationTimes);
                stopTime2 = System.currentTimeMillis();
                if (true) System.out.println("EndOfGeneration:"+(stopTime2-startTime2)/1000d+"s"+"("+Thread.currentThread().activeCount()+")");
            }

            cma.updateDistribution(fitness);         // pass fitness array to update search distribution

            stopTime2 = System.currentTimeMillis();
            if (true) System.out.println("EndUpdateDistribution:"+(stopTime2-startTime2)/1000d+"s"+"("+Thread.currentThread().activeCount()+")");

            // --- end core iteration step ---

            // output to files and console
            if (!true) {
                cma.writeToDefaultFiles();
                int outmod = 15;
                if (cma.getCountIter() % (15 * outmod) == 1) {
                    cma.printlnAnnotation(); // might write file as well
                }
                if (cma.getCountIter() % outmod == 1) {
                    cma.println();
                }
            }

            stopTime = System.currentTimeMillis();
            if (printSeveralOutputsPerCMARun) System.out.println("seconds needed for this generation:"+(stopTime-startTime)/1000d);
            if (printSeveralOutputsPerCMARun) System.out.println("countResamplesPerGeneration:"+countResamplesPerGeneration);
            if (printSeveralOutputsPerCMARun) System.out.println("countResamplesPerRun:"+countResamplesPerRun);



            if (cma.getCountIter() % 100==0) {
            System.out.println(cma.sigma);
            print2DArray(cma.C); }
        }

        if (printSeveralOutputsPerCMARun) System.out.println("["+(cma.getCountIter()-1)+":"+1d/cma.getBestFunctionValue()+"]");


        // evaluate mean value as it is the best estimator for the optimum
        cma.setFitnessOfMeanX(fitfun.valueOf(cma.getMeanX(), false)); // updates the best ever solution


        //hide a lot of output
        if (false) {
            // final output
            cma.writeToDefaultFiles(1);
            cma.println();
            cma.println("Terminated due to");
            for (String s : cma.stopConditions.getMessages()) {
                cma.println("  " + s);
            }
            cma.println("best function value " + 1d/cma.getBestFunctionValue()
                    + " at evaluation " + cma.getBestEvaluationNumber());

            // we might return cma.getBestSolution() or cma.getBestX()
        }
        //System.out.println("["+cma.getCountIter()+":"+1d/cma.getBestFunctionValue()+"]");
        if (printSeveralOutputsPerCMARun) System.out.println("countResamplesPerRun:"+countResamplesPerRun);
        return cma.getBestSolution();
    }




    public static void print2DArray(double[][] a) {
        for (double[] i:a) {
            for (double d:i) {
                System.out.printf("%6.3f " , d);
            }
            System.out.println();
        }
        System.out.println();
    }


} // class




///*******************************************************************************
// * A simple example I used to learn how to use CMA.
// *
// * @author mwagner
// *******************************************************************************
// */
//class Simple implements IObjectiveFunction { // meaning implements methods valueOf and isFeasible
//
//    public double border = 0.5;
//
//    // fitness function
//    public double valueOf(double[] x) {
//        double res = 0;
//        for (int i = 0; i < x.length; i++) {
//            res += Math.abs(x[i]-border);
//        }
//        return res;
//    }
//
//    // define what is a feasible solution
//    public boolean isFeasible(double[] x) {
////        for (int i = 0; i < x.length; i++) {
////            if (x[i] < border) {
////                return false;
////            }
////        }
//        return true;
//    }
//}
//


class DateUtils {
  public static final String DATE_FORMAT_NOW = "yyyy-MM-dd HH:mm:ss";

  public static String now() {
    Calendar cal = Calendar.getInstance();
    SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
    return sdf.format(cal.getTime());
  }

  public static void  main2(String arg[]) {
    System.out.println("Now : " + DateUtils.now());
  }
}